QGIS Application - Bug report #12610
QGIS not showing WMS legend while LegendURL is present
2015-04-20 06:51 AM - Kay Warrie

Status: Closed

Priority: Normal

Assignee:

Category: Web Services clients/WMS

Affected QGIS version:2.8.1 Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 20729
Description

I'am reporting on issue my customer, the Flemish government has reported.
In all of our wms-services, we define a WMS-legend url inside the /WMS_Capabilities/Capability/Layer/Style/LegendURL tag.
But these aren't shown in the table of contents in QGIS.

For example the wms:
http://geo.agiv.be/ogc/wms/product/INBO?SERVICE=WMS&#38;VERSION=1.3.0&#38;request=GetCapabilities

For the layer BWK1Zone the legend url is defined as:
http://geo.agiv.be/ogc/wms/product/INBO?request=GetLegendGraphic%26version=1.3.0%26format=image/png%26layer=BWK1Zone
--> works fine in openlayers and other gis-applications, but not in QGIS.

For wms-services of the Brussels Government these Legends are shown:
http://wms.ibgebim.be/cgi-bin/ibgewms.exe?SERVICE=WMS&#38;VERSION=1.3.0&#38;request=GetCapabilities

For the layer bruenvi_natura_2000_buffer the legend url is defined as:

http://wms.ibgebim.be/ibgewms?sld version=1.1.0&#38;version=1.3.0&#38;service=WMS&#38;request=GetLegendGraphic&#38;form
t=image/png&#38;layer=bruenvi_natura 2000 buffer

--> works in openlayers and QGIS.

Is this a Bug in QGIS?
The original question to me in dutch is added as a attachment.

History

#1 - 2015-04-28 08:10 AM - Filip Mahieu
- File LegendError.png added

We do have a similar error here. When loading the WMS

url=http://wms.agiv.be/ogc/wms/omkl&layers=Ortho&format=image/png&styles=default&crs=EPSG:31370 by means of that discribed plugin, we get the

error 'Returned legend image is flawed', see attachment.

When then using this layer in a composer, Qgis blocks. So this really an issue i think!

Thanks for looking at this!

#2 - 2015-04-28 08:20 AM - Filip Mahieu
- File LegendError2Composer.png added
http://geo.agiv.be/ogc/wms/product/INBO?SERVICE=WMS&#38;VERSION=1.3.0&#38;request=GetCapabilities
http://geo.agiv.be/ogc/wms/product/INBO?request=GetLegendGraphic%26version=1.3.0%26format=image/png%26layer=BWK1Zone
http://wms.ibgebim.be/cgi-bin/ibgewms.exe?SERVICE=WMS&#38;VERSION=1.3.0&#38;request=GetCapabilities
http://wms.ibgebim.be/ibgewms?sld_version=1.1.0&#38;version=1.3.0&#38;service=WMS&#38;request=GetLegendGraphic&#38;format=image/png&#38;layer=bruenvi_natura_2000_buffer
http://wms.ibgebim.be/ibgewms?sld_version=1.1.0&#38;version=1.3.0&#38;service=WMS&#38;request=GetLegendGraphic&#38;format=image/png&#38;layer=bruenvi_natura_2000_buffer

More specific: QGis blocks when effectively adding the legend in the composer. You see in attachment what you get after adding the legend in the
composer. you don't get a legend at all, it's rather blank, but there is space.
Then you can't do anything anymore but closing the composer and then Qgis.

#3 - 2015-05-07 01:36 AM - Giovanni Manghi
- Target version changed from Version 2.8 to Version 2.8.2

- Operating System deleted (all)

#4 - 2015-05-14 03:03 AM - Giovanni Manghi
- Target version changed from Version 2.8.2 to Version 2.10

#5 - 2015-07-24 04:40 AM - Filip Mahieu

- Assignee set to Nyall Dawson

Does this issue have a relation with solved #122347?

#6 - 2015-07-24 02:32 PM - Nyall Dawson
- Assignee deleted (Nyall Dawson)

This issue seems to consist of two separate issues. The second (composer hang) is fixed in 2.10 and will be in 2.8.3, not sure if the first is fixed (not

showing legend).

#7 - 2015-08-14 01:07 AM - Filip Mahieu

Nyall Dawson wrote:

This issue seems to consist of two separate issues. The second (composer hang) is fixed in 2.10 and will be in 2.8.3, not sure if the first is fixed (not

showing legend).

Indeed, the 'composer hang' is fixed in 2.8.3. But there's still no legend.

#8 - 2015-10-14 12:58 AM - Henrik Uggla

If I give a layer a (external) legendURL and do GetCapabilities | get:

<Style>

<Name>default</Name>

<Title>default</Title>

<LegendURL>

<Format>image/png</Format>

<OnlineResource xmins:xlink="http://www.w3.0rg/1999/xlink" xlink:type="simple" xlink:href="http://www.osgeo.org/sites/all/themes/osgeo/logo.png"/>
</LegendURL>

</Style>

Which is correct. But when | do GetLegendGraphic | get a simple marker instead. Is this the same bug or should | open a new one (for Qgis Server)?
Qgis Server 2.8.2 on Ubuntu 14.4

Nevermind, I've opened a new bug: 13595

#9 - 2015-11-07 11:26 AM - Giovanni Manghi

- Target version deleted (Version 2.10)

#10 - 2016-04-08 02:21 AM - Patrick Valsecchi

I'm not sure QGIS is doing anything wrong, there. The URL given for BWK1Zone is clearly wrong. It has only one parameter named request and it has this
value: GetLegendGraphic%26version=1.3.0%26format=image/png%26layer=BWK1Zone

If you look at the URL given for layer bruenvi_natura_2000_buffer, it has 7 parameters and they are all good.

This is due of the wrongfull replacement of the "&" by "%26" in the URLs in the first case.

#11 - 2016-07-01 05:05 AM - johan sanders

legend is displayed in qgis version 2.15.0 revision 600ff4f |

in ggis version 2.14.3 it is not displayed !

#12 - 2016-07-20 08:24 AM - Giovanni Manghi
- Status changed from Open to Feedback

How is the situation in 2.16? it could have been solved and today also backported to 2.14.

#13 - 2016-08-22 05:37 AM - Stefan Blumentrath

In 2.16.1 on OSGeo4W (64bit)

http://wms.reindrift.no? does not show a legend either.

It says: "Error downloading http://wms.reindrift.no?language=nor&#38;version=1."

While it should show e.g. this:
http://wmes.reindrift.no/?sld_version=1.1.0&#38;version=1.3.0&#38;service=WMS&#38;request=GetLegendGraphic&#38;format=image/png&#38;layer=
EINDRIFT

The server behind the WMS is Mapserver 7.0.1.

#14 - 2016-10-17 03:48 AM - Filip Mahieu

As | can see, in QGis 2.14.7 it is resolved using the WMS Kay Warrie gave. | use a lot of WMS'es from the Flemish Government and they now all seem

fine.

For my part, the issue can be closed.
http://wms.reindrift.no
http://wms.reindrift.no?language=nor&#38;version=1
http://wms.reindrift.no/?sld_version=1.1.0&#38;version=1.3.0&#38;service=WMS&#38;request=GetLegendGraphic&#38;format=image/png&#38;layer=REINDRIFT
http://wms.reindrift.no/?sld_version=1.1.0&#38;version=1.3.0&#38;service=WMS&#38;request=GetLegendGraphic&#38;format=image/png&#38;layer=REINDRIFT

#15 - 2017-01-02 06:39 AM - Giovanni Manghi
- Status changed from Feedback to Closed
- Resolution set to fixed/implemented

Files

Vraag_ivm_QGIS.pdf 353 KB 2015-04-20 Kay Warrie

LegendError.png 347 KB 2015-04-28 Filip Mahieu

LegendError2Composer.png 200 KB 2015-04-28 Filip Mahieu
